/* Copyright (c) <2003-2022> <Julio Jerez, Newton Game Dynamics>
* 
* This software is provided 'as-is', without any express or implied
* warranty. In no event will the authors be held liable for any damages
* arising from the use of this software.
* 
* Permission is granted to anyone to use this software for any purpose,
* including commercial applications, and to alter it and redistribute it
* freely, subject to the following restrictions:
* 
* 1. The origin of this software must not be misrepresented; you must not
* claim that you wrote the original software. If you use this software
* in a product, an acknowledgment in the product documentation would be
* appreciated but is not required.
* 
* 2. Altered source versions must be plainly marked as such, and must not be
* misrepresented as being the original software.
* 
* 3. This notice may not be removed or altered from any source distribution.
*/

#ifndef __ND_CORE_H__
#define __ND_CORE_H__

#include <ndCoreStdafx.h>
#include <ndCRC.h>
#include <ndRand.h>
#include <ndList.h>
#include <ndTree.h>
#include <ndHeap.h>
#include <ndSort.h>
#include <ndTypes.h>
#include <ndUtils.h>
#include <ndArray.h>
#include <ndStack.h>
#include <ndDebug.h>
#include <ndPlane.h>
#include <ndVector.h>
#include <ndMatrix.h>
#include <ndThread.h>
#include <ndMemory.h>
#include <ndGoogol.h>
#include <ndString.h>
#include <ndFastRay.h>
#include <ndFastAabb.h>
#include <ndProfiler.h>
#include <ndPolyhedra.h>
#include <ndSyncMutex.h>
#include <ndSemaphore.h>
#include <ndSharedPtr.h>
#include <ndClassAlloc.h>
#include <ndThreadPool.h>
#include <ndIsoSurface.h>
#include <ndQuaternion.h>
#include <ndPerlinNoise.h>
#include <ndTinyXmlGlue.h>
#include <ndFixSizeArray.h>
#include <ndConvexHull2d.h>
#include <ndConvexHull3d.h>
#include <ndConvexHull4d.h>
#include <ndBezierSpline.h>
#include <ndSaveLoadSytem.h>
#include <ndNodeHierarchy.h>
#include <ndIntersections.h>
#include <ndSpatialVector.h>
#include <ndSpatialMatrix.h>
#include <ndGeneralVector.h>
#include <ndGeneralMatrix.h>
#include <ndTemplateVector.h>
#include <ndContainersAlloc.h>
#include <ndAabbPolygonSoup.h>
#include <ndSmallDeterminant.h>
#include <ndConjugateGradient.h>
#include <ndPolygonSoupBuilder.h>
#include <ndPolygonSoupDatabase.h>
#include <ndThreadBackgroundWorker.h>
#include <ndPolyhedraMassProperties.h>
#include <ndDelaunayTetrahedralization.h>

#endif

